import { __awaiter } from 'tslib';
import { classToClass, plainToClass } from 'class-transformer';
import { getFromContainer, MetadataStorage, validate, validateSync, ValidationTypes, Validator } from 'class-validator';
import { cloneDeep, mergeWith } from 'lodash-es';
import 'reflect-metadata';
import { BehaviorSubject } from 'rxjs';
import { FormControl, FormArray, FormBuilder, FormGroup } from '@angular/forms';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DynamicFormControl extends FormControl {
    /**
     * @param {?} fieldDefinition
     */
    constructor(fieldDefinition) {
        super(fieldDefinition.data, fieldDefinition.validationFunctions);
        this.validationDefinitions = fieldDefinition.validationDefinitions;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template TModel
 */
class DynamicFormGroup extends FormGroup {
    /**
     * @param {?} factoryModel
     * @param {?} fields
     * @param {?=} defaultValidatorOptions
     */
    constructor(factoryModel, fields, defaultValidatorOptions) {
        super({});
        this.factoryModel = factoryModel;
        this.defaultValidatorOptions = defaultValidatorOptions;
        this.customValidateErrors = new BehaviorSubject({});
        this._fb = new FormBuilder();
        /*
        const classValidators = DynamicFormGroup.getClassValidators<TModel>(
          this.factoryModel,
          this.fields,
          this.defaultValidatorOptions
        );
        const formGroup = this._fb.group(
          classValidators
        );
        Object.keys(formGroup.controls).forEach(key => {
          this.addControl(key, formGroup.controls[key]);
        });
        this.valueChanges.subscribe(data => {
          this.validate(
            undefined,
            this.defaultValidatorOptions
          );
        });*/
        this.formFields = this.onlyFields(fields);
    }
    // Getters & Setters
    /**
     * @param {?} externalErrors
     * @return {?}
     */
    set externalErrors(externalErrors) {
        this._externalErrors = externalErrors;
        this.validate();
    }
    /**
     * @return {?}
     */
    get externalErrors() {
        return this._externalErrors;
    }
    /**
     * @param {?} validatorOptions
     * @return {?}
     */
    set validatorOptions(validatorOptions) {
        this._validatorOptions = validatorOptions;
        this.validate();
    }
    /**
     * @return {?}
     */
    get validatorOptions() {
        return this._validatorOptions;
    }
    /**
     * @param {?} object
     * @return {?}
     */
    set object(object) {
        this.setObject(object);
    }
    /**
     * @return {?}
     */
    get object() {
        return this.getObject();
    }
    // Public API
    /**
     * @param {?=} externalErrors
     * @param {?=} validatorOptions
     * @return {?}
     */
    validate(externalErrors, validatorOptions) {
        this.validateAsync(externalErrors, validatorOptions).then(() => { }, error => {
            throw error;
        });
    }
    /**
     * @param {?=} externalErrors
     * @param {?=} validatorOptions
     * @return {?}
     */
    validateAsync(externalErrors, validatorOptions) {
        return __awaiter(this, void 0, void 0, function* () {
            if (externalErrors === undefined) {
                externalErrors = cloneDeep(this._externalErrors);
            }
            if (validatorOptions === undefined) {
                validatorOptions = cloneDeep(this._validatorOptions);
            }
            if (!externalErrors) {
                externalErrors = {};
            }
            try {
                /** @type {?} */
                const result = yield validate(this.object, validatorOptions);
                /** @type {?} */
                const validationErrors = this.transformValidationErrors(result);
                /** @type {?} */
                const allErrors = this.mergeErrors(externalErrors, validationErrors);
                this.markAsInvalidForExternalErrors(externalErrors, this.controls);
                this.formErrors = allErrors;
                this.customValidateErrors.next(this.formErrors);
            }
            catch (error) {
                throw error;
            }
        });
    }
    /**
     * @return {?}
     */
    validateAllFormFields() {
        Object.keys(this.controls).forEach(field => {
            /** @type {?} */
            const control = this.get(field);
            // Control
            if (control instanceof FormControl) {
                control.markAsTouched({ onlySelf: true });
            }
            // Group: recursive
            else if (control instanceof DynamicFormGroup) {
                control.validateAllFormFields();
            }
            // Array
            else if (control instanceof FormArray) {
                for (let i = 0; i < ((/** @type {?} */ (control))).controls.length; i++) {
                    // Control in Array
                    if (((/** @type {?} */ (control))).controls[i] instanceof FormControl) {
                        ((/** @type {?} */ (((/** @type {?} */ (control))).controls[i]))).markAsTouched({ onlySelf: true });
                    }
                    // Group in Array: recursive
                    else if (((/** @type {?} */ (control))).controls[i] instanceof DynamicFormGroup) {
                        ((/** @type {?} */ (((/** @type {?} */ (control))).controls[i]))).validateAllFormFields();
                    }
                }
            }
        });
    }
    /**
     * @template TClassModel
     * @param {?} object
     * @return {?}
     */
    classToClass(object) {
        return classToClass(object, { ignoreDecorators: true });
    }
    /**
     * @template TClassModel, Object
     * @param {?} cls
     * @param {?} plain
     * @return {?}
     */
    plainToClass(cls, plain) {
        return plainToClass(cls, plain, { ignoreDecorators: true });
    }
    /**
     * @param {?} externalErrors
     * @return {?}
     */
    setExternalErrorsAsync(externalErrors) {
        return __awaiter(this, void 0, void 0, function* () {
            this._externalErrors = externalErrors;
            try {
                return yield this.validateAsync();
            }
            catch (error) {
                throw error;
            }
        });
    }
    /**
     * @param {?} externalErrors
     * @return {?}
     */
    setExternalErrors(externalErrors) {
        this.setExternalErrorsAsync(externalErrors).then(() => { }, error => {
            throw error;
        });
    }
    /**
     * @return {?}
     */
    getExternalErrors() {
        return this._externalErrors;
    }
    /**
     * @return {?}
     */
    clearExternalErrors() {
        this.setExternalErrors({});
    }
    /**
     * @return {?}
     */
    clearExternalErrorsAsync() {
        return this.setExternalErrorsAsync({});
    }
    /**
     * @param {?} validatorOptions
     * @return {?}
     */
    setValidatorOptionsAsync(validatorOptions) {
        return __awaiter(this, void 0, void 0, function* () {
            this._validatorOptions = validatorOptions;
            try {
                return yield this.validateAsync();
            }
            catch (error) {
                throw error;
            }
        });
    }
    /**
     * @param {?} validatorOptions
     * @return {?}
     */
    setValidatorOptions(validatorOptions) {
        this.setValidatorOptionsAsync(validatorOptions).then(() => { }, error => {
            throw error;
        });
    }
    /**
     * @return {?}
     */
    getValidatorOptions() {
        return this._validatorOptions;
    }
    // Helpers
    /**
     * @private
     * @param {?} fields
     * @return {?}
     */
    onlyFields(fields) {
        /** @type {?} */
        const newFields = {};
        if (fields !== undefined) {
            Object.keys(fields).forEach(key => {
                if (fields[key] instanceof DynamicFormGroup) {
                    // Group: recursive
                    newFields[key] = this.onlyFields(((/** @type {?} */ (fields[key]))).formFields);
                }
                else {
                    // Array
                    if (fields[key] instanceof FormArray) {
                        if (((/** @type {?} */ (fields[key]))).controls[0] instanceof DynamicFormGroup) {
                            // Group within Array: recursive
                            newFields[key] = this.onlyFields(((/** @type {?} */ (((/** @type {?} */ (fields[key]))).controls[0]))).formFields);
                        }
                        else {
                            // Control within Array
                            newFields[key] = ((/** @type {?} */ (fields[key]))).controls[0].value;
                        }
                    }
                    else {
                        // Handle Control
                        newFields[key] = fields[key];
                    }
                }
            });
        }
        return newFields;
    }
    /**
     * @private
     * @param {?} errors
     * @return {?}
     */
    transformValidationErrors(errors) {
        /** @type {?} */
        const customErrors = {};
        errors.forEach((error) => {
            if (error && error.constraints !== undefined) {
                Object.keys(error.constraints).forEach((key) => {
                    if (!customErrors[error.property]) {
                        customErrors[error.property] = [];
                    }
                    if (((/** @type {?} */ (customErrors[error.property]))).indexOf(error.constraints[key]) === -1) {
                        ((/** @type {?} */ (customErrors[error.property]))).push(error.constraints[key]);
                    }
                });
            }
            if (error.children !== undefined && error.children.length) {
                customErrors[error.property] = this.transformValidationErrors(error.children);
            }
        });
        return customErrors;
    }
    /**
     * @private
     * @param {?=} errors
     * @param {?=} externalErrors
     * @return {?}
     */
    mergeErrors(errors, externalErrors) {
        return mergeWith(errors, externalErrors, (objValue, srcValue) => {
            if (canMerge()) {
                return objValue.concat(srcValue);
            }
            /**
             * @return {?}
             */
            function canMerge() {
                return (Array.isArray(objValue) &&
                    Array.isArray(srcValue) &&
                    objValue.filter(objItem => srcValue.indexOf(objItem) !== -1).length === 0);
            }
        });
    }
    /**
     * @private
     * @param {?} errors
     * @param {?} controls
     * @return {?}
     */
    markAsInvalidForExternalErrors(errors, controls) {
        Object.keys(controls).forEach(field => {
            /** @type {?} */
            const control = controls[field];
            // Control
            if (control instanceof FormControl) {
                if (errors && errors[field]) {
                    control.setErrors({ externalError: true });
                }
                else if (control.errors && control.errors.externalError === true) {
                    control.setErrors(null);
                }
            }
            // Group
            else if (control instanceof DynamicFormGroup) {
                control.markAsInvalidForExternalErrors(errors && errors[field] ? ((/** @type {?} */ (errors[field]))) : {}, control.controls);
            }
            // Array
            else if (control instanceof FormArray) {
                for (let i = 0; i < ((/** @type {?} */ (control))).length; i++) {
                    // Control in Array
                    if (control[i] instanceof FormControl) {
                        if (errors && errors[i] && errors[i][field]) {
                            control[i].setErrors({ externalError: true });
                        }
                        else if (control[i].errors && control[i].errors.externalError === true) {
                            control[i].setErrors(null);
                        }
                    }
                    // Group in Array
                    else if (control[i] instanceof DynamicFormGroup) {
                        control[i].markAsInvalidForExternalErrors(errors && errors[i] && errors[i][field] ? ((/** @type {?} */ (errors[i][field]))) : {}, control[i].controls);
                    }
                }
            }
        });
    }
    /**
     * Recursively gets all values from the form controls and all sub form group and array controls and returns it as
     * an object
     * @private
     * @return {?}
     */
    getObject() {
        // Initialize the shape of the response
        /** @type {?} */
        const object = this._object ? this.classToClass(this._object) : new this.factoryModel();
        if (object !== undefined) {
            // Recursively get the value of all fields
            Object.keys(this.controls).forEach(key => {
                // Handle Group
                if (this.controls[key] instanceof DynamicFormGroup) {
                    object[key] = ((/** @type {?} */ (this.controls[key]))).object;
                }
                // Handle Form Array
                else if (this.controls[key] instanceof FormArray) {
                    // Initialize value
                    object[key] = [];
                    for (let i = 0; i < ((/** @type {?} */ (this.controls[key]))).controls.length; i++) {
                        /** @type {?} */
                        let value;
                        if (((/** @type {?} */ (this.controls[key]))).controls[i] instanceof DynamicFormGroup) {
                            // Recursively get object group
                            value = ((/** @type {?} */ (((/** @type {?} */ (this.controls[key]))).controls[i]))).object;
                        }
                        else {
                            value = ((/** @type {?} */ (this.controls[key]))).controls[i].value;
                        }
                        object[key].push(value);
                    }
                }
                // Handle Control
                else {
                    object[key] = this.controls[key].value;
                }
            });
        }
        return this.plainToClass(this.factoryModel, object);
    }
    /**
     * Sets the value of every control on the form and recursively sets the values of the controls
     * on all sub form groups
     *
     * @private
     * @param {?} object the data to assign to all controls of the form group and sub groups
     * @return {?}
     */
    setObject(object) {
        if (object instanceof this.factoryModel) {
            this._object = this.classToClass(object); // Ensure correct type
        }
        else {
            this._object = this.plainToClass(this.factoryModel, (/** @type {?} */ (object))); // Convert to Model type
        }
        // Recursively set the value of all fields
        Object.keys(this.controls).forEach(key => {
            // Handle Group
            if (this.controls[key] instanceof DynamicFormGroup) {
                ((/** @type {?} */ (this.controls[key]))).object = this._object ? this._object[key] : {};
            }
            // Handle FormArray
            else if (this.controls[key] instanceof FormArray) {
                /** @type {?} */
                const objectArray = this._object ? this._object[key] : [];
                /** @type {?} */
                const formArray = (/** @type {?} */ (this.controls[key]));
                /** @type {?} */
                const isFormGroup = formArray.controls[0] instanceof DynamicFormGroup;
                /** @type {?} */
                const prevFormGroup = (/** @type {?} */ (formArray.controls[0]));
                /** @type {?} */
                const formControl = (/** @type {?} */ (formArray.controls[0]));
                // Clear FormArray while retaining the reference
                while (formArray.length !== 0) {
                    formArray.removeAt(0);
                }
                for (let i = 0; i < objectArray.length; i++) {
                    if (isFormGroup) {
                        // Create FormGroup
                        /** @type {?} */
                        const dynamicFormGroup = new DynamicFormGroup(prevFormGroup.factoryModel, prevFormGroup.formFields, this._validatorOptions);
                        dynamicFormGroup.setParent(this);
                        /** @type {?} */
                        const classValidators = getClassValidators(prevFormGroup.factoryModel, prevFormGroup.formFields, this._validatorOptions);
                        /** @type {?} */
                        const formGroup = this._fb.group(classValidators);
                        // Add all controls to the form group
                        Object.keys(formGroup.controls).forEach(ctrlKey => {
                            dynamicFormGroup.addControl(ctrlKey, formGroup.controls[ctrlKey]);
                        });
                        // Add a value change listener to the group. on change, validate
                        dynamicFormGroup.valueChanges.subscribe(data => {
                            dynamicFormGroup.validate(undefined, this._validatorOptions);
                        });
                        formArray.controls.push(dynamicFormGroup);
                        // Recusrively set the object value
                        ((/** @type {?} */ (formArray.controls[i]))).object =
                            this._object && objectArray && objectArray[i] ? objectArray[i] : {};
                    }
                    else {
                        // Create control
                        /** @type {?} */
                        const controlValue = this._object && objectArray && objectArray[i] ? objectArray[i] : undefined;
                        /** @type {?} */
                        const newFormControl = new FormControl(controlValue, formControl.validator);
                        newFormControl.setParent(this);
                        // Add the control to the FormArray
                        formArray.controls.push(newFormControl);
                    }
                }
            }
            // Handle Control
            else {
                /** @type {?} */
                const newObject = this._object ? this._object[key] : [];
                this.controls[key].setValue(this._object && newObject ? newObject : undefined);
            }
        });
    }
}
/**
 * @template TModel
 * @param {?} factoryModel
 * @param {?} fields
 * @param {?=} validatorOptions
 * @return {?}
 */
function getClassValidators(factoryModel, fields, validatorOptions) {
    // Get the validation rules from the object decorators
    /** @type {?} */
    const allValidationMetadatas = getFromContainer(MetadataStorage).getTargetValidationMetadatas(factoryModel, '');
    // Get the validation rules for the validation group: https://github.com/typestack/class-validator#validation-groups
    /** @type {?} */
    const validationGroupMetadatas = getFromContainer(MetadataStorage).getTargetValidationMetadatas(factoryModel, '', validatorOptions && validatorOptions.groups ? validatorOptions.groups : undefined);
    /** @type {?} */
    const formGroupFields = {};
    /** @type {?} */
    const validator = new Validator();
    // Loop through all fields in the form definition
    Object.keys(fields)
        .filter(key => key.indexOf('__') !== 0)
        .forEach(fieldName => {
        // Conditional Validation for the field
        /** @type {?} */
        const conditionalValidations = [];
        validationGroupMetadatas.forEach(validationMetadata => {
            if (isPropertyValidatorOfType(validationMetadata, fieldName, ValidationKeys.conditional.type)) {
                conditionalValidations.push(validationMetadata);
            }
        });
        // All Nested Validation for the field
        /** @type {?} */
        const allNestedValidations = [];
        allValidationMetadatas.forEach(validationMetadata => {
            if (isPropertyValidatorOfType(validationMetadata, fieldName, ValidationKeys.nested.type)) {
                allNestedValidations.push(validationMetadata);
            }
        });
        // Nested Validation for the field for the requested class-validator group
        /** @type {?} */
        const nestedGroupValidations = [];
        validationGroupMetadatas.forEach(validationMetadata => {
            if (isPropertyValidatorOfType(validationMetadata, fieldName, ValidationKeys.nested.type)) {
                nestedGroupValidations.push(validationMetadata);
            }
        });
        /** @type {?} */
        const fieldDefinition = {
            data: formGroupFields[fieldName],
            validationFunctions: [],
            validationDefinitions: []
        };
        if (fieldDefinition.data === undefined) {
            fieldDefinition.data = fields[fieldName];
        }
        validationGroupMetadatas.forEach(validationMetadata => {
            if (validationMetadata.propertyName === fieldName &&
                validationMetadata.type !== ValidationKeys.conditional.type) {
                // Add all validation to the field except the @NestedValidation definition as
                // being part of the form would imply it is validated if any other rules are present
                if (validationMetadata.type !== ValidationKeys.nested.type) {
                    fieldDefinition.validationDefinitions.push(validationMetadata);
                }
                for (const typeKey in ValidationTypes) {
                    if (ValidationTypes.hasOwnProperty(typeKey)) {
                        // Handle Nested Validation
                        if (checkWithAllNestedValidations(allNestedValidations, nestedGroupValidations, fieldName)) {
                            if (isNestedValidate(validationMetadata, typeKey)) {
                                /** @type {?} */
                                const objectToValidate = fields[fieldName] instanceof DynamicFormGroup ? fields[fieldName].object : undefined;
                                /** @type {?} */
                                const nestedValidate = createNestedValidate(objectToValidate, validationMetadata);
                                setFieldData(fieldName, fieldDefinition, nestedValidate);
                            }
                        }
                        // Handle Custom Validation
                        if (isCustomValidate(validationMetadata, typeKey)) {
                            /** @type {?} */
                            const customValidation = createCustomValidation(fieldName, validationMetadata);
                            setFieldData(fieldName, fieldDefinition, customValidation);
                        }
                        // Handle remaining validation
                        if (isDynamicValidate(validationMetadata, typeKey)) {
                            /** @type {?} */
                            const dynamicValidate = createDynamicValidate(validationMetadata, conditionalValidations, fieldName);
                            setFieldData(fieldName, fieldDefinition, dynamicValidate);
                        }
                    }
                }
            }
        });
        // Convert to a structure, angular understands
        if (fieldDefinition.data instanceof DynamicFormGroup || fieldDefinition.data instanceof FormArray) {
            formGroupFields[fieldName] = fieldDefinition.data;
        }
        else {
            formGroupFields[fieldName] = new DynamicFormControl(fieldDefinition);
        }
    });
    return formGroupFields;
    // ******************************************************************************************
    // Local Helper functions to help make the main code more readable
    //
    /**
     * @param {?} objectToValidate
     * @param {?} validationMetadata
     * @return {?}
     */
    function createNestedValidate(objectToValidate, validationMetadata) {
        return function (control) {
            /** @type {?} */
            const isValid = getValidateErrors(control, objectToValidate !== undefined ? objectToValidate : control.value, validatorOptions)
                .length === 0;
            return getIsValidResult(isValid, validationMetadata, 'nestedValidate');
        };
    }
    /**
     * @param {?} validationMetadata
     * @param {?} conditionalValidations
     * @param {?} fieldName
     * @return {?}
     */
    function createDynamicValidate(validationMetadata, conditionalValidations, fieldName) {
        return function (control) {
            if (!control) {
                return null;
            }
            /** @type {?} */
            let isValid = control.parent && control.parent.value
                ? validator.validateValueByMetadata(control.value, validationMetadata)
                : true;
            if (!isValid && conditionalValidations.length > 0) {
                /** @type {?} */
                const validateErrors = setObjectValueAndGetValidationErrors(control, fieldName, validatorOptions);
                isValid = validateErrors.filter((error) => error.property === fieldName).length === 0;
            }
            return getIsValidResult(isValid, validationMetadata, 'dynamicValidate');
        };
    }
    /**
     * @param {?} fieldName
     * @param {?} validationMetadata
     * @return {?}
     */
    function createCustomValidation(fieldName, validationMetadata) {
        return function (control) {
            /** @type {?} */
            const validateErrors = setObjectValueAndGetValidationErrors(control, fieldName, validatorOptions);
            /** @type {?} */
            const isValid = getAllErrors(validateErrors, fieldName).length === 0;
            return getIsValidResult(isValid, validationMetadata, 'customValidation');
        };
    }
    /**
     * @param {?} allNestedValidations
     * @param {?} nestedValidations
     * @param {?} key
     * @return {?}
     */
    function checkWithAllNestedValidations(allNestedValidations, nestedValidations, key) {
        return (allNestedValidations.length === nestedValidations.length ||
            ((fields[key] instanceof DynamicFormGroup || fields[key] instanceof FormArray) &&
                (allNestedValidations.length > 0 && nestedValidations.length === 0)));
    }
    /**
     * @param {?} validationMetadata
     * @param {?} typeKey
     * @return {?}
     */
    function isDynamicValidate(validationMetadata, typeKey) {
        return validationMetadata.type === ValidationTypes[typeKey] && validator[validationMetadata.type] !== undefined;
    }
    /**
     * marked with \@Validate(...)
     * https://github.com/typestack/class-validator#custom-validation-classes
     * @param {?} validationMetadata
     * @param {?} typeKey
     * @return {?}
     */
    function isCustomValidate(validationMetadata, typeKey) {
        return (isNotPropertyValidation(validationMetadata, typeKey) &&
            validationMetadata.type === ValidationKeys.custom.type &&
            typeKey === ValidationKeys.custom.typeKey);
    }
    /**
     * marked with \@ValidateNested()
     * https://github.com/typestack/class-validator#validating-nested-objects
     * @param {?} validationMetadata
     * @param {?} typeKey
     * @return {?}
     */
    function isNestedValidate(validationMetadata, typeKey) {
        return (isNotPropertyValidation(validationMetadata, typeKey) &&
            validationMetadata.type === ValidationKeys.nested.type &&
            typeKey === ValidationKeys.nested.typeKey);
    }
    /**
     * @param {?} validationMetadata
     * @param {?} typeKey
     * @return {?}
     */
    function isNotPropertyValidation(validationMetadata, typeKey) {
        return validationMetadata.type === ValidationTypes[typeKey] && validator[validationMetadata.type] === undefined;
    }
    /**
     * @param {?} fieldName
     * @param {?} fieldDefinition
     * @param {?} validationFunction
     * @return {?}
     */
    function setFieldData(fieldName, fieldDefinition, validationFunction) {
        if (fields[fieldName] instanceof DynamicFormGroup) {
            fields[fieldName].object = fields[fieldName].fields;
        }
        // Fill field data if empty
        if (fieldDefinition.data === undefined) {
            fieldDefinition.data = fields[fieldName];
        }
        fieldDefinition.validationFunctions.push(validationFunction);
    }
    /**
     * @param {?} validateErrors
     * @param {?} fieldName
     * @return {?}
     */
    function getAllErrors(validateErrors, fieldName) {
        return validateErrors.filter((error) => 
        // Check for nested/child errors
        error.children.length && error.children.filter(children => children.property === fieldName));
    }
}
// ***************************************************************
// Global Helper functions
//
/**
 * @param {?} validationMetadata
 * @param {?} fieldName
 * @param {?} validationMetadataType
 * @return {?}
 */
function isPropertyValidatorOfType(validationMetadata, fieldName, validationMetadataType) {
    return validationMetadata.propertyName === fieldName && validationMetadata.type === validationMetadataType;
}
/**
 * @param {?} control
 * @param {?} key
 * @param {?} validatorOptions
 * @return {?}
 */
function setObjectValueAndGetValidationErrors(control, key, validatorOptions) {
    /** @type {?} */
    const object = control.parent instanceof DynamicFormGroup
        ? ((/** @type {?} */ (control.parent))).object
        : control.parent
            ? control.parent.value
            : {};
    if (object) {
        object[key] = control.value;
    }
    return getValidateErrors(control, object, validatorOptions);
}
/**
 * @param {?} control
 * @param {?} dataToValidate
 * @param {?} validatorOptions
 * @return {?}
 */
function getValidateErrors(control, dataToValidate, validatorOptions) {
    /** @type {?} */
    const validateErrors = control.parent && control.parent.value ? validateSync(dataToValidate, validatorOptions) : [];
    return validateErrors;
}
/**
 * @param {?} isValid
 * @param {?} validationMetadata
 * @param {?} errorType
 * @return {?}
 */
function getIsValidResult(isValid, validationMetadata, errorType) {
    return isValid
        ? null
        : {
            [errorType]: {
                valid: false,
                type: validationMetadata.type
            }
        };
}
/** @type {?} */
const ValidationKeys = {
    nested: {
        type: 'nestedValidation',
        typeKey: 'NESTED_VALIDATION'
    },
    conditional: {
        type: 'conditionalValidation'
    },
    custom: {
        type: 'customValidation',
        typeKey: 'CUSTOM_VALIDATION'
    }
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DynamicFormBuilder extends FormBuilder {
    // ******************
    // Public API
    /**
     * @template TModel
     * @param {?} factoryModel
     * @param {?=} controlsConfig
     * @param {?=} extra
     * @return {?}
     */
    group(factoryModel, controlsConfig, extra) {
        // Process the group with the controlsConfig passed into extra instead. (What does this accomplish?)
        if (controlsConfig &&
            (((/** @type {?} */ (controlsConfig))).legacyOrOpts ||
                ((/** @type {?} */ (controlsConfig))).customValidatorOptions)) {
            return this.group(factoryModel, undefined, controlsConfig);
        }
        // Set default customValidatorOptions
        if (extra !== undefined && extra.customValidatorOptions === undefined) {
            extra.customValidatorOptions = { validationError: { target: false } };
        }
        /** @type {?} */
        let newControlsConfig;
        if (controlsConfig !== undefined) {
            newControlsConfig = (/** @type {?} */ (controlsConfig));
        }
        // experimental
        if (controlsConfig === undefined) {
            newControlsConfig = Object.assign({}, this.createEmptyObject(factoryModel));
            Object.keys(newControlsConfig).forEach(key => {
                if (canCreateGroup()) {
                    // recursively create a dynamic group for the nested object
                    newControlsConfig[key] = this.group(newControlsConfig[key].constructor, extra);
                }
                else {
                    if (canCreateArray()) {
                        if (newControlsConfig[key][0].constructor) {
                            // recursively create an array with a group
                            newControlsConfig[key] = super.array(newControlsConfig[key].map(newControlsConfigItem => this.group(newControlsConfigItem.constructor, extra)));
                        }
                        else {
                            // Create an array of form controls
                            newControlsConfig[key] = super.array(newControlsConfig[key].map(newControlsConfigItem => this.control(newControlsConfigItem)));
                        }
                    }
                }
                /**
                 * @return {?}
                 */
                function canCreateGroup() {
                    /** @type {?} */
                    const candidate = newControlsConfig[key];
                    return (candidate &&
                        !Array.isArray(candidate) &&
                        candidate.constructor &&
                        typeof candidate === 'object' &&
                        (candidate.length === undefined ||
                            (candidate.length !== undefined && Object.keys(candidate).length === candidate.length)));
                }
                /**
                 * @return {?}
                 */
                function canCreateArray() {
                    if (Array.isArray(newControlsConfig[key]) === false) {
                        return false;
                    }
                    /** @type {?} */
                    const candidate = newControlsConfig[key][0];
                    return (candidate.constructor &&
                        typeof candidate === 'object' &&
                        (candidate.length === undefined ||
                            (candidate.length !== undefined && Object.keys(candidate).length === candidate.length)));
                }
            });
        }
        // Create an Angular group from the top-level object
        /** @type {?} */
        const classValidators = getClassValidators(factoryModel, newControlsConfig, this.getExtraValidationOptions(extra));
        /** @type {?} */
        const formGroup = super.group(classValidators, extra);
        // Initialize the resulting group
        /** @type {?} */
        const dynamicFormGroup = new DynamicFormGroup(factoryModel, newControlsConfig, this.getExtraValidationOptions(extra));
        // Add all angular controls to the resulting dynamic group
        Object.keys(formGroup.controls).forEach(key => {
            dynamicFormGroup.addControl(key, formGroup.controls[key]);
        });
        // Add a listener to the dynamic group for value changes; on change, execute validation
        dynamicFormGroup.valueChanges.subscribe(data => {
            dynamicFormGroup.validate(undefined, this.getExtraValidationOptions(extra));
        });
        return dynamicFormGroup;
    }
    // *******************
    // Helpers
    /**
     * Recursively creates an empty object from the data provided
     * @private
     * @template TModel
     * @param {?} factoryModel
     * @param {?=} data
     * @return {?}
     */
    createEmptyObject(factoryModel, data = {}) {
        /** @type {?} */
        let modifed = false;
        /** @type {?} */
        const object = factoryModel ? plainToClass(factoryModel, data) : data;
        /** @type {?} */
        const fields = Object.keys(object);
        fields.forEach((fieldName) => {
            if (object[fieldName] && object[fieldName].length !== undefined) {
                if (object[fieldName].length === 1 &&
                    Object.keys(object[fieldName][0]).length > 0 &&
                    object[fieldName][0].constructor) {
                    object[fieldName] = [this.createEmptyObject(object[fieldName][0].constructor)];
                }
                if (object[fieldName].length === 0) {
                    data[fieldName] = [{}];
                    modifed = true;
                }
            }
            else {
                data[fieldName] = undefined;
            }
        });
        if (modifed) {
            return this.createEmptyObject(factoryModel, data);
        }
        return object;
    }
    /**
     * Helper for getting the customValidatorOptions
     * @private
     * @param {?} extra
     * @return {?}
     */
    getExtraValidationOptions(extra) {
        return extra && extra.customValidatorOptions ? extra.customValidatorOptions : undefined;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { DynamicFormBuilder, DynamicFormControl, getClassValidators, DynamicFormGroup };

//# sourceMappingURL=ngx-dynamic-form-builder.js.map